Loading...
Searching...
No Matches
fastnoise_source.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2013,2018 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef FASTNOISE_SOURCE_H
#define FASTNOISE_SOURCE_H
#include <gnuradio/analog/api.h>
#include <gnuradio/analog/noise_type.h>
#include <gnuradio/sync_block.h>
#include <cstdint>
#include <vector>
namespace gr {
namespace analog {
/*!
* \brief Random number source
* \ingroup source_blk
*
* \details
* Generate random values from different distributions.
* Currently, only Gaussian and uniform are enabled.
*/
template <class T>
class ANALOG_API fastnoise_source : virtual public sync_block
{
public:
// gr::analog::fastnoise_source::sptr
typedef std::shared_ptr<fastnoise_source<T>> sptr;
/*! \brief Make a fast noise source
* \param type the random distribution to use (see
* gnuradio/analog/noise_type.h)
* \param ampl the standard deviation of a 1-d noise process. If
* this is the complex source, this parameter is split
* among the real and imaginary parts:
* <pre>(ampl/sqrt(2))x + j(ampl/sqrt(2))y</pre>
* \param seed seed for random generators. seed = 0 initializes
* the random number generator with the system time.
* \param samples Number of samples to pre-generate. For performance
* reasons, prefer a power of 2.
*/
static sptr
make(noise_type_t type, float ampl, uint64_t seed = 0, size_t samples = 1024 * 16);
virtual T sample() = 0;
virtual T sample_unbiased() = 0;
virtual const std::vector<T>& samples() const = 0;
/*!
* Set the noise type. Nominally from the
* gr::analog::noise_type_t selections, but only GR_GAUSSIAN and
* GR_UNIFORM are currently available.
*/
virtual void set_type(noise_type_t type) = 0;
/*!
* Set the standard deviation (amplitude) of the 1-d noise
* process.
*/
virtual void set_amplitude(float ampl) = 0;
virtual noise_type_t type() const = 0;
virtual float amplitude() const = 0;
};
typedef fastnoise_source<float> fastnoise_source_f;
typedef fastnoise_source<std::int32_t> fastnoise_source_i;
typedef fastnoise_source<std::int16_t> fastnoise_source_s;
typedef fastnoise_source<gr_complex> fastnoise_source_c;
} /* namespace analog */
} /* namespace gr */
#endif /* FASTNOISE_SOURCE_H */
gr::analog::fastnoise_source
Random number source.
Definition fastnoise_source.h:34
gr::analog::fastnoise_source::set_amplitude
virtual void set_amplitude(float ampl)=0
gr::analog::fastnoise_source< float >::samples
virtual const std::vector< float > & samples() const=0
gr::analog::fastnoise_source::make
static sptr make(noise_type_t type, float ampl, uint64_t seed=0, size_t samples=1024 *16)
Make a fast noise source.
gr::analog::fastnoise_source::amplitude
virtual float amplitude() const =0
gr::analog::fastnoise_source< float >::type
virtual noise_type_t type() const=0
gr::analog::fastnoise_source::sample
virtual T sample()=0
gr::analog::fastnoise_source::set_type
virtual void set_type(noise_type_t type)=0
gr::analog::fastnoise_source::sample_unbiased
virtual T sample_unbiased()=0
gr::analog::fastnoise_source::sptr
std::shared_ptr< fastnoise_source< T > > sptr
Definition fastnoise_source.h:37
gr::sync_block::sync_block
sync_block(void)
Definition sync_block.h:28
api.h
ANALOG_API
#define ANALOG_API
Definition gr-analog/include/gnuradio/analog/api.h:18
gr::analog
Definition agc.h:19
gr::analog::fastnoise_source_f
fastnoise_source< float > fastnoise_source_f
Definition fastnoise_source.h:74
gr::analog::noise_type_t
noise_type_t
Definition noise_type.h:17
gr::analog::fastnoise_source_c
fastnoise_source< gr_complex > fastnoise_source_c
Definition fastnoise_source.h:77
gr::analog::fastnoise_source_i
fastnoise_source< std::int32_t > fastnoise_source_i
Definition fastnoise_source.h:75
gr::analog::fastnoise_source_s
fastnoise_source< std::int16_t > fastnoise_source_s
Definition fastnoise_source.h:76
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
noise_type.h
sync_block.h